<template>
  <q-page class="q-pl-md bg-grey-1" v-if="table" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <template v-if="show_render">
          <q-card class="shadow-1" flat bordered>
            <q-expansion-item label="Rendered table" header-class="heading_expansion__table" default-opened
                              expand-icon-class="text-orange-10" switch-toggle-side role="heading">
              <HtmlTable
                :dts_name="dts_name"
                :nt_version="nt_version"
                :linkrole_id="table.linkrole_id"
                class="q-pb-sm"
                v-on:nodeClicked="node_clicked"
              ></HtmlTable>
            </q-expansion-item>
          </q-card>
        </template>

        <TableDetailCard v-bind:table="table"></TableDetailCard>
        <ParameterDetail v-bind:table="table" v-if="table.parameters.length"></ParameterDetail>
      </template>

      <template v-slot:separator>
      </template>

      <template v-slot:after>
        <div v-if="node">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>
    </q-splitter>
  </q-page>
</template>

<script>
/* VariableDetail verwijderd, die hoort elders ...*/
import {api} from 'boot/axios'
import TableDetailCard from "components/TableDetailCard";
import ParameterDetail from "components/ParameterDetail";
import HtmlTable from "components/HtmlTable";
import CellValue from "components/CellValue";

export default {
  name: "TableDetail",
  components: {HtmlTable, ParameterDetail, TableDetailCard, CellValue},
  data() {
    return {
      table: undefined,
      all_tables: null,
      node: undefined,
      panelWidth: 100,
    }
  },
  props: {
    table_id: String,
    dts_name: String,
    nt_version: String,
  },
  mounted() {
    if (this.all_tables === null) {
      this.fetchData()
    }
  },
  watch: {
    table_id: function () {
      this.fetchData()
    }
  },
  methods: {
    fetchData: function () {
      if (typeof (this.dts_name) !== 'undefined') {
        api
          .get("/dts/" + this.dts_name + "/tables/" + this.table_id,
            {params: {nt_version: this.nt_version, full: 1}})
          .then(response => {
            this.table = response.data[0]
          })
      }
    },
    node_clicked: function (node) {
      if (node) {
        this.node = node
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    }
  },
  computed: {
    show_render: function () {
      if (this.$route.path.includes("/tables")) {
        return true
      }
      return false
    }
  }
}
</script>

<style scoped>

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}

table {
  border-spacing: 5px;
  widht: 100%;
}

th {
  text-align: left;
}

</style>
